[CCode (cheader_filename = "gtksourceview/gtksourceview.h")]
namespace Gtk {
	[CCode (cheader_filename = "gtksourceview/gtksourceundomanager.h")]
	public class SourceUndoManager : GLib.Object {
		[NoArrayLength ()]
		public void begin_not_undoable_action ();
		[NoArrayLength ()]
		public void end_not_undoable_action ();
		[NoArrayLength ()]
		public int get_max_undo_levels ();
		[NoArrayLength ()]
		public GLib.Type get_type ();
		[NoArrayLength ()]
		public construct (Gtk.TextBuffer buffer);
		[NoArrayLength ()]
		public void redo ();
		[NoArrayLength ()]
		public void set_max_undo_levels (int undo_levels);
		[NoArrayLength ()]
		public void undo ();
		public signal void can_undo (bool can_undo);
		public signal void can_redo (bool can_redo);
	}
	[CCode (cheader_filename = "gtksourceview/gtksourcebuffer.h")]
	public class SourceBuffer : Gtk.TextBuffer {
		[NoArrayLength ()]
		public void begin_not_undoable_action ();
		[NoArrayLength ()]
		public Gtk.SourceMarker create_marker (string name, string type, Gtk.TextIter where);
		[NoArrayLength ()]
		public void delete_marker (Gtk.SourceMarker marker);
		[NoArrayLength ()]
		public void end_not_undoable_action ();
		[NoArrayLength ()]
		public bool get_check_brackets ();
		[NoArrayLength ()]
		public unichar get_escape_char ();
		[NoArrayLength ()]
		public Gtk.SourceMarker get_first_marker ();
		[NoArrayLength ()]
		public bool get_highlight ();
		[NoArrayLength ()]
		public void get_iter_at_marker (Gtk.TextIter iter, Gtk.SourceMarker marker);
		[NoArrayLength ()]
		public Gtk.SourceLanguage get_language ();
		[NoArrayLength ()]
		public Gtk.SourceMarker get_last_marker ();
		[NoArrayLength ()]
		public Gtk.SourceMarker get_marker (string name);
		[NoArrayLength ()]
		public GLib.SList get_markers_in_region (Gtk.TextIter begin, Gtk.TextIter end);
		[NoArrayLength ()]
		public int get_max_undo_levels ();
		[NoArrayLength ()]
		public Gtk.SourceMarker get_next_marker (Gtk.TextIter iter);
		[NoArrayLength ()]
		public Gtk.SourceMarker get_prev_marker (Gtk.TextIter iter);
		[NoArrayLength ()]
		public GLib.Type get_type ();
		[NoArrayLength ()]
		public void move_marker (Gtk.SourceMarker marker, Gtk.TextIter where);
		[NoArrayLength ()]
		public construct (Gtk.SourceTagTable table);
		[NoArrayLength ()]
		public construct with_language (Gtk.SourceLanguage language);
		[NoArrayLength ()]
		public void redo ();
		[NoArrayLength ()]
		public void set_bracket_match_style (Gtk.SourceTagStyle style);
		[NoArrayLength ()]
		public void set_check_brackets (bool check_brackets);
		[NoArrayLength ()]
		public void set_escape_char (unichar escape_char);
		[NoArrayLength ()]
		public void set_highlight (bool highlight);
		[NoArrayLength ()]
		public void set_language (Gtk.SourceLanguage language);
		[NoArrayLength ()]
		public void set_max_undo_levels (int max_undo_levels);
		[NoArrayLength ()]
		public void undo ();
		[NoArrayLength ()]
		[CCode (cname = "gtk_source_buffer_can_undo")]
		public bool undo_available ();
		[NoArrayLength ()]
		[CCode (cname = "gtk_source_buffer_can_redo")]
		public bool redo_available ();
		public weak unichar escape_char { get; set; }
		public weak bool check_brackets { get; set; }
		public weak bool highlight { get; set; }
		public weak int max_undo_levels { get; set; }
		public weak Gtk.SourceLanguage language { get; set; }
		public signal void can_undo (bool can_undo);
		public signal void can_redo (bool can_redo);
		public signal void highlight_updated (Gtk.TextIter start, Gtk.TextIter end);
		public signal void marker_updated (Gtk.TextIter where);
	}
	[CCode (cheader_filename = "gtksourceview/gtksourcelanguage.h")]
	public class SourceLanguage : GLib.Object {
		[NoArrayLength ()]
		public unichar get_escape_char ();
		[NoArrayLength ()]
		public string get_id ();
		[NoArrayLength ()]
		public GLib.SList get_mime_types ();
		[NoArrayLength ()]
		public string get_name ();
		[NoArrayLength ()]
		public string get_section ();
		[NoArrayLength ()]
		public Gtk.SourceStyleScheme get_style_scheme ();
		[NoArrayLength ()]
		public Gtk.SourceTagStyle get_tag_default_style (string tag_id);
		[NoArrayLength ()]
		public Gtk.SourceTagStyle get_tag_style (string tag_id);
		[NoArrayLength ()]
		public GLib.SList get_tags ();
		[NoArrayLength ()]
		public GLib.Type get_type ();
		[NoArrayLength ()]
		public void set_mime_types (GLib.SList mime_types);
		[NoArrayLength ()]
		public void set_style_scheme (Gtk.SourceStyleScheme scheme);
		[NoArrayLength ()]
		public void set_tag_style (string tag_id, Gtk.SourceTagStyle style);
		public signal void tag_style_changed (string name);
	}
	[CCode (cheader_filename = "gtksourceview/gtksourcelanguagesmanager.h")]
	public class SourceLanguagesManager : GLib.Object {
		[NoArrayLength ()]
		public GLib.SList get_available_languages ();
		[NoArrayLength ()]
		public GLib.SList get_lang_files_dirs ();
		[NoArrayLength ()]
		public Gtk.SourceLanguage get_language_from_mime_type (string mime_type);
		[NoArrayLength ()]
		public GLib.Type get_type ();
		[NoArrayLength ()]
		public construct ();
		[NoAccessorMethod ()]
		public weak pointer lang_files_dirs { get; construct; }
	}
	[CCode (cheader_filename = "gtksourceview/gtksourcemarker.h")]
	public class SourceMarker {
		[NoArrayLength ()]
		public Gtk.SourceBuffer get_buffer ();
		[NoArrayLength ()]
		public int get_line ();
		[NoArrayLength ()]
		public string get_marker_type ();
		[NoArrayLength ()]
		public string get_name ();
		[NoArrayLength ()]
		public GLib.Type get_type ();
		[NoArrayLength ()]
		public Gtk.SourceMarker next ();
		[NoArrayLength ()]
		public Gtk.SourceMarker prev ();
		[NoArrayLength ()]
		public void set_marker_type (string type);
	}
	[CCode (cheader_filename = "gtksourceview/gtksourcetagtable.h")]
	public class SourceTagTable : Gtk.TextTagTable {
		[NoArrayLength ()]
		public void add_tags (GLib.SList tags);
		[NoArrayLength ()]
		public GLib.Type get_type ();
		[NoArrayLength ()]
		public construct ();
		[NoArrayLength ()]
		public void remove_source_tags ();
		public signal void changed ();
	}
	[CCode (cheader_filename = "gtksourceview/gtksourceview.h")]
	public class SourceView : Gtk.TextView {
		[NoArrayLength ()]
		public bool get_auto_indent ();
		[NoArrayLength ()]
		public bool get_highlight_current_line ();
		[NoArrayLength ()]
		public bool get_indent_on_tab ();
		[NoArrayLength ()]
		public bool get_insert_spaces_instead_of_tabs ();
		[NoArrayLength ()]
		public uint get_margin ();
		[NoArrayLength ()]
		public Gdk.Pixbuf get_marker_pixbuf (string marker_type);
		[NoArrayLength ()]
		public bool get_show_line_markers ();
		[NoArrayLength ()]
		public bool get_show_line_numbers ();
		[NoArrayLength ()]
		public bool get_show_margin ();
		[NoArrayLength ()]
		public bool get_smart_home_end ();
		[NoArrayLength ()]
		public uint get_tabs_width ();
		[NoArrayLength ()]
		public GLib.Type get_type ();
		[NoArrayLength ()]
		public construct ();
		[NoArrayLength ()]
		public construct with_buffer (Gtk.SourceBuffer buffer);
		[NoArrayLength ()]
		public void set_auto_indent (bool enable);
		[NoArrayLength ()]
		public void set_highlight_current_line (bool show);
		[NoArrayLength ()]
		public void set_indent_on_tab (bool enable);
		[NoArrayLength ()]
		public void set_insert_spaces_instead_of_tabs (bool enable);
		[NoArrayLength ()]
		public void set_margin (uint margin);
		[NoArrayLength ()]
		public void set_marker_pixbuf (string marker_type, Gdk.Pixbuf pixbuf);
		[NoArrayLength ()]
		public void set_show_line_markers (bool show);
		[NoArrayLength ()]
		public void set_show_line_numbers (bool show);
		[NoArrayLength ()]
		public void set_show_margin (bool show);
		[NoArrayLength ()]
		public void set_smart_home_end (bool enable);
		[NoArrayLength ()]
		public void set_tabs_width (uint width);
		[NoArrayLength ()]
		public static string gettext (string msgid);
		public weak bool show_line_numbers { get; set; }
		public weak bool show_line_markers { get; set; }
		public weak uint tabs_width { get; set; }
		public weak bool auto_indent { get; set; }
		public weak bool insert_spaces_instead_of_tabs { get; set; }
		public weak bool show_margin { get; set; }
		public weak uint margin { get; set; }
		public weak bool smart_home_end { get; set; }
		public weak bool highlight_current_line { get; set; }
		public weak bool indent_on_tab { get; set; }
		public signal void undo ();
		public signal void redo ();
	}
	[CCode (cheader_filename = "gtksourceview/gtksourcestylescheme.h")]
	public interface SourceStyleScheme {
		[NoArrayLength ()]
		public Gtk.SourceStyleScheme get_default ();
		[NoArrayLength ()]
		public string get_name ();
		[NoArrayLength ()]
		public virtual GLib.SList get_style_names ();
		[NoArrayLength ()]
		public virtual Gtk.SourceTagStyle get_tag_style (string style_name);
		[NoArrayLength ()]
		public GLib.Type get_type ();
	}
	[ReferenceType ()]
	public struct SourceBufferMatch {
		public weak int startpos;
		public weak int endpos;
		public weak int startindex;
		public weak int endindex;
	}
	[ReferenceType ()]
	public struct SourceRegex {
		[NoArrayLength ()]
		public static Gtk.SourceRegex compile (string pattern);
		[NoArrayLength ()]
		public void destroy ();
		[NoArrayLength ()]
		public bool match (string text, int pos, int len, uint options);
		[NoArrayLength ()]
		public int search (string text, int pos, int length, Gtk.SourceBufferMatch match, uint options);
	}
	public struct SourceTagStyle {
		[NoArrayLength ()]
		public Gtk.SourceTagStyle copy ();
		[NoArrayLength ()]
		public void free ();
		[NoArrayLength ()]
		public GLib.Type get_type ();
		[NoArrayLength ()]
		public construct ();
	}
	[ReferenceType ()]
	public struct TextRegion {
		[NoArrayLength ()]
		public void add (Gtk.TextIter _start, Gtk.TextIter _end);
		[NoArrayLength ()]
		public void debug_print ();
		[NoArrayLength ()]
		public void destroy (bool delete_marks);
		[NoArrayLength ()]
		public Gtk.TextBuffer get_buffer ();
		[NoArrayLength ()]
		public void get_iterator (Gtk.TextRegionIterator iter, uint start);
		[NoArrayLength ()]
		public Gtk.TextRegion intersect (Gtk.TextIter _start, Gtk.TextIter _end);
		[NoArrayLength ()]
		public construct (Gtk.TextBuffer buffer);
		[NoArrayLength ()]
		public bool nth_subregion (uint subregion, Gtk.TextIter start, Gtk.TextIter end);
		[NoArrayLength ()]
		public int subregions ();
		[NoArrayLength ()]
		public void subtract (Gtk.TextIter _start, Gtk.TextIter _end);
	}
	[ReferenceType ()]
	public struct TextRegionIterator {
		[NoArrayLength ()]
		public void get_subregion (Gtk.TextIter start, Gtk.TextIter end);
		[NoArrayLength ()]
		public bool is_end ();
		[NoArrayLength ()]
		public bool next ();
	}
	[ReferenceType ()]
	public struct SourceIter {
		[NoArrayLength ()]
		public static bool backward_search (Gtk.TextIter iter, string str, Gtk.SourceSearchFlags @flags, Gtk.TextIter match_start, Gtk.TextIter match_end, Gtk.TextIter limit);
		[NoArrayLength ()]
		public static bool find_matching_bracket (Gtk.TextIter iter);
		[NoArrayLength ()]
		public static bool forward_search (Gtk.TextIter iter, string str, Gtk.SourceSearchFlags @flags, Gtk.TextIter match_start, Gtk.TextIter match_end, Gtk.TextIter limit);
	}
	[CCode (cprefix = "GTK_SOURCE_REGEX_NOT_")]
	public enum SourceRegexOptions {
		BOL,
		EOL,
	}
	[CCode (cprefix = "GTK_SOURCE_SEARCH_", cheader_filename = "gtksourceview/gtksourceiter.h")]
	public enum SourceSearchFlags {
		VISIBLE_ONLY,
		TEXT_ONLY,
		CASE_INSENSITIVE,
	}
	[CCode (cprefix = "GTK_SOURCE_TAG_STYLE_USE_")]
	public enum SourceTagStyleMask {
		BACKGROUND,
		FOREGROUND,
	}
}
